package com.jiuqi.util;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.StringUtils;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;

public class Html {
  public static String getHtmlColor(int colorValue) {
    String returnStr = "";
    if (colorValue < 0) {
      returnStr = getSystemColor(colorValue);
    } else {
      returnStr = "#" + repairLength(Integer.toHexString(BGR2RGB(colorValue)));
    } 
    return returnStr;
  }
  
  public static int BGR2RGB(int color) {
    if (color < 0)
      return color; 
    int red = (color & 0xFF) << 16;
    int blue = (color & 0xFF0000) >> 16;
    int green = color & 0xFF00;
    return red | blue | green;
  }
  
  private static String repairLength(String colorStr) {
    if (colorStr == null)
      return "000000"; 
    if (colorStr.length() == 6)
      return colorStr; 
    StringBuffer buffer = new StringBuffer(colorStr);
    while (buffer.length() < 6)
      buffer.insert(0, '0'); 
    return buffer.toString();
  }
  
  private static final String[] SYS_COLOR_NAMES = new String[] { 
      "scrollbar", "background", "activecaption", "inactivecaption", "menu", 
      
      "window", "windowframe", "menutext", "windowtext", "captiontext", 
      "inactiveborder", "inactivecaption", "appworkspace", "highlight", "highlighttext", 
      
      "buttonface", "buttonshadow", "graytext", "buttontext", "inactivecaption", 
      "buttonhighlight", "threeddarkshadow", "threedhighlight", "infotext", "infobackground" };
  
  private static final int SYS_COLOR_MASK = -16777216;
  
  public static String getSystemColor(int intColor) {
    if ((intColor & 0xFF000000) != -16777216)
      return ""; 
    int colorValue = intColor & 0xFFFFFF;
    return (colorValue < SYS_COLOR_NAMES.length) ? SYS_COLOR_NAMES[colorValue] : "";
  }
  
  public static String strToHtml(String instring) {
    int lIndex = 0;
    if (instring == null)
      return ""; 
    StringBuffer lStrbuff = new StringBuffer(instring);
    while (lIndex < lStrbuff.length()) {
      char lChar = lStrbuff.charAt(lIndex);
      if ((lChar = lStrbuff.charAt(lIndex)) == '"') {
        lStrbuff.replace(lIndex, lIndex + 1, "&#34;");
        lIndex += 5;
        continue;
      } 
      if (lChar == '&') {
        lStrbuff.replace(lIndex, lIndex + 1, "&amp;");
        lIndex += 5;
        continue;
      } 
      if (lChar == '<') {
        lStrbuff.replace(lIndex, lIndex + 1, "&lt;");
        lIndex += 4;
        continue;
      } 
      if (lChar == '>') {
        lStrbuff.replace(lIndex, lIndex + 1, "&gt;");
        lIndex += 4;
        continue;
      } 
      if (lChar == ' ') {
        lStrbuff.replace(lIndex, lIndex + 1, "&nbsp;");
        lIndex += 6;
        continue;
      } 
      lIndex++;
    } 
    return lStrbuff.toString();
  }
  
  public static String encodeText(String inString) {
    if (inString == null)
      return ""; 
    int lIndex = 0;
    char endChar = Character.MIN_VALUE;
    StringBuffer outString = new StringBuffer(inString);
    while (lIndex < outString.length()) {
      char lChar = outString.charAt(lIndex);
      if (lIndex + 1 < outString.length())
        endChar = outString.charAt(lIndex + 1); 
      if (lChar == '&') {
        outString.replace(lIndex, lIndex + 1, "&amp;");
        lIndex += 5;
        continue;
      } 
      if (lChar == '<') {
        outString.replace(lIndex, lIndex + 1, "&lt;");
        lIndex += 4;
        continue;
      } 
      if (lChar == '>') {
        outString.replace(lIndex, lIndex + 1, "&gt;");
        lIndex += 4;
        continue;
      } 
      if ((lChar = outString.charAt(lIndex)) == '"') {
        outString.replace(lIndex, lIndex + 1, "&#34;");
        lIndex += 5;
        continue;
      } 
      if (lChar == '\r' && endChar == '\n') {
        outString.replace(lIndex, lIndex + 2, "<br>");
        lIndex += 4;
        continue;
      } 
      if (lChar == ' ') {
        outString.replace(lIndex, lIndex + 1, "&nbsp;");
        lIndex += 6;
        continue;
      } 
      lIndex++;
    } 
    return outString.toString();
  }
  
  public static String Double2Str(double value) {
    DecimalFormat df = new DecimalFormat("#.#");
    return df.format(value);
  }
  
  public static String fmtDouble(double value) {
    DecimalFormat df = new DecimalFormat("0.0000");
    return df.format(value);
  }
  
  public static String encodeHashMap(HashMap hashMap) {
    if (hashMap == null || hashMap.isEmpty())
      return null; 
    StringBuffer result = new StringBuffer();
    Iterator keys = hashMap.keySet().iterator();
    while (keys.hasNext()) {
      Object key = keys.next();
      result.append(key);
      result.append(':');
      Object value = hashMap.get(key);
      if (value != null)
        result.append(value); 
      result.append(';');
    } 
    if (result.length() > 0)
      result.deleteCharAt(result.length() - 1); 
    return result.toString();
  }
  
  public static HashMap decodeHashMap(String s) {
    if (StringUtils.isEmpty(s))
      return null; 
    HashMap<Object, Object> result = new HashMap<Object, Object>();
    String[] maps = s.split(";");
    if (maps == null)
      return result; 
    for (int i = 0; i < maps.length; i++) {
      if (!StringUtils.isEmpty(maps[i])) {
        String[] entries = maps[i].split(":");
        if (entries != null)
          if (entries.length == 1) {
            result.put(entries[0], null);
          } else if (entries.length == 2) {
            result.put(entries[0], entries[1]);
          }  
      } 
    } 
    return result;
  }
}
